POJ-3126 Prime Path (BFS)

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0


题目大意:一个四位数,一步可以将某一位上的数字变为任意数字,但要保证结果仍然是四位素数,求将一个四位素数变为另一个四位素数的最小步骤数。
思路分析:赤裸裸的BFS。预先处理出素数。

代码如下:
 1 # include<iostream>
 2 # include<cstdio>
 3 # include<queue>
 4 # include<cstring>
 5 # include<algorithm>
 6 using namespace std;
 7 int mark[10005],vis[10005],base[4];
 8 struct node
 9 {
10     int num,t;
11     node(int a,int b):num(a),t(b){}
12 };
13 void init()
14 {
15     memset(mark,0,sizeof(mark));
16     mark[1]=1;
17     for(int i=2;i<=10000;++i){
18         if(mark[i])
19             continue;
20         for(int j=2*i;j<=10000;j+=i)
21             mark[j]=1;
22     }
23     base[0]=1;
24     for(int i=1;i<4;++i)
25         base[i]=base[i-1]*10;
26 }
27 void bfs(int s,int e)
28 {
29     memset(vis,0,sizeof(vis));
30     queue<node>q;
31     vis[s]=1;
32     q.push(node(s,0));
33     while(!q.empty()){
34         node u=q.front();
35         q.pop();
36         if(u.num==e){
37             printf("%d
",u.t);
38             return ;
39         }
40         for(int i=0;i<4;++i){
41             int now=u.num;
42             int cur=now%(base[i]*10);
43             cur/=base[i];
44             now=now-cur*base[i];
45             for(int k=0;k<=9;++k){
46                 int temp=now+base[i]*k;
47                 if(temp>1000&&!mark[temp]&&!vis[temp]){
48                     vis[temp]=1;
49                     q.push(node(temp,u.t+1));
50                 }
51             }
52         }
53     }
54 }
55 int main()
56 {
57     init();
58     int a,b,T;
59     scanf("%d",&T);
60     while(T--)
61     {
62         scanf("%d%d",&a,&b);
63         bfs(a,b);
64     }
65     return 0;
66 }
View Code
原文地址:https://www.cnblogs.com/20143605--pcx/p/4726227.html